-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp, SQLskills.com
-- All Rights Reserved.
-- 
-- For more scripts, sample code and additional training resources,
-- go to http://www.SQLskills.com
--	Immerse yourself in SQL Server
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


SET STATISTICS IO ON
-- Turn Graphical Showplan ON (Ctrl+K)

UPDATE dbo.member
	SET firstname = 'Kimberly'
	WHERE member_no = 2345
go
DROP PROC GetMemberInfoParam
DROP PROC GetMemberInfoParam2
DROP PROC GetMemberInfoParam3
go
CREATE PROC GetMemberInfoParam
	@Lastname	varchar(30) = NULL,
	@Firstname	varchar(30) = NULL,
	@member_no	int = NULL
AS
SELECT * FROM member
WHERE (lastname LIKE @lastname OR @lastname IS NULL)
	AND (member_no = @member_no OR @member_no IS NULL)
	AND (firstname LIKE @firstname OR @firstname IS NULL)
go

exec GetMemberInfoParam	@Lastname = 'Tripp' with recompile
go
exec GetMemberInfoParam	@Firstname = 'Kimberly' with recompile
go
exec GetMemberInfoParam	@Member_no = 9912 with recompile
go

CREATE PROC GetMemberInfoParam2
	@Lastname	varchar(30) = NULL,
	@Firstname	varchar(30) = NULL,
	@member_no	int = NULL
AS
SELECT * FROM member
WHERE lastname = ISNULL(@lastname, lastname)
	AND member_no = ISNULL(@member_no, member_no)
	AND firstname =  ISNULL(@firstname, firstname)
go

exec GetMemberInfoParam2	@Lastname = 'Tripp' with recompile
go
exec GetMemberInfoParam2	@Firstname = 'Kimberly' with recompile
go
exec GetMemberInfoParam2	@Member_no = 9912 with recompile
go

CREATE PROC GetMemberInfoParam3
	@Lastname	varchar(30) = NULL,
	@Firstname	varchar(30) = NULL,
	@member_no	int = NULL
AS
IF @LastName IS NULL AND @FirstName IS NULL AND @Member_no IS NULL
	RAISERROR ('You must supply at least one parameter.', 16, -1)

DECLARE @ExecStr	varchar(1000),
	@MemberNoStr	varchar(100)
SELECT @ExecStr = 'SELECT * FROM member WHERE ' 

IF @LastName IS NOT NULL
	SELECT @Lastname = 'lastname LIKE ' + QUOTENAME(@lastname, '''')
IF @FirstName IS NOT NULL
	SELECT @Firstname = 'firstname LIKE ' + QUOTENAME(@firstname, '''')
IF @Member_no IS NOT NULL
	SELECT @MemberNoStr = 'member_no = ' + convert(varchar(5), @member_no)

SELECT @ExecStr = @ExecStr + ISNULL(@LastName, ' ') 
	+ 
	CASE
		WHEN @LastName IS NOT NULL AND @FirstName IS NOT NULL
			THEN ' AND '
		ELSE ' '
	END
	+
	ISNULL(@FirstName, ' ') 
	+ 
	CASE
		WHEN (@LastName IS NOT NULL OR @FirstName IS NOT NULL)
					AND @MemberNoStr IS NOT NULL
			THEN ' AND '
		ELSE ' '
	END
	+
	ISNULL(@MemberNoStr, ' ')

EXEC(@ExecStr)
go
exec GetMemberInfoParam3	@Lastname = 'test', @FirstName = 'Kimberly' 
go
exec GetMemberInfoParam3	@Firstname = 'Kimberly' 
go
exec GetMemberInfoParam3	@Firstname = 'Kimberly', @Member_no = 842 
go
exec GetMemberInfoParam3	@Member_no = 9912 
go
exec GetMemberInfoParam3	@Lastname = 'Florini', @Member_no = 9912 
go
go
